# Bottle Royale

A survival action game made for Ludum Dare 54 (theme: "Limited Space").

You are an insect stuck in a bottle and you have to fight for your survival.

The official repository is at [dev.nales.org](https://dev.nales.org/bottle-royale).

## Launching the game on your computer locally

If you want to launch the game on your computer, launch the `run` command:

```
./run
```

You will need to go to the link displayed (usually http://0.0.0.0:8000/). The
script uses Python 3. If you do not have Python 3, find another way to launch
the game in a web server. This step is necessary because web browsers will
prevent web pages to load local data for security reasons.

The game was developed on Linux. The script should work fine on Linux, BSD and
MacOS systems. If you have another operating system such as Windows or Haiku,
good luck I guess?

## On the code

I wanted to go back to my roots and write the game in a procedural and
imperative way: global methods take objects and work with them. No methods are
really bound to a specific object.

If you want to learn "good" and "modern" JavaScript development, this is not
the right place. Overall I am happy with my way to work: it makes refactoring
easier no methods share the same name in the source code.

But gosh I hate non-statically typed languages! They are a pain to deal with
when it comes to refactoring the code!

On the variable types used in the code, except specified otherwise:

* all time is in seconds;
* all speeds are by seconds;
* all angles are in degrees.

## License and copyright

This project is licensed under the Apache License, Version 2.0. The terms and
conditions of this license are in the `LICENSE` file.

The copyright notice:

```
Bottle Royale - Ludum Dare 54 edition
Copyright 2023 Alex Canales (Nales)

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
```
