/**
 * @state The state of something.
 */

/**
 * Keeps the state of something and manages its remaining time.
 * @typedef ItemState
 * @property {boolean} doing  Is the item doing its stuff.
 * @property {float} remainingTime  The remaining time for the item to do its stuff.
 */

function BR_ItemState_create() {
	let state = {
		doing : false,
		remainingTime : 0,
	};
	return state;
}

function BR_ItemState_reset(state) {
	state.remainingTime = 0;
	state.doing = false;
}

function BR_ItemState_start(state, remainingTime) {
	state.doing = true;
	state.remainingTime = remainingTime;
}

/**
 * Consumes the item.
 */
function BR_ItemState_consume(state, elapsedTime) {
	state.remainingTime -= elapsedTime;
	if(state.remainingTime <= 0) {
		BR_ItemState_reset(state);
	}
}
